#include <stdio.h>
#include <conio.h>
#include <iostream.h>

int main()
{
  unsigned char readbyte;
  unsigned char readbyte2; //used to check for repetitious chars
  int reps;
  unsigned char readfile[13];
  unsigned char writefile[13];
  long int fontoff=0;
  long int lastoff=0x5FF;
  long int backoff=0;     //original font offset (for multi-00/FF check)
  long int romoff=0x7769;
  long int compsize=0;
  cout<<"Dungeon Kid Font Recompressor\n";
  cout<<" (c)2004 KingMike\n";
  FILE *font=fopen("dkef2.dat","rb");
  FILE *ROM=fopen("dunkidj.nes","r+");
  while(fontoff<=lastoff)
  {
     fseek(font,fontoff,SEEK_SET);
     readbyte=fgetc(font);
     if(readbyte==0x99||readbyte==0xAA||readbyte==0xBB||readbyte==0xCC||readbyte==0xDD||readbyte==0xEE)
     {
        fseek(ROM,romoff,SEEK_SET);
        fputc((char)0x99,ROM);
        romoff++;
        compsize++;
        fseek(ROM,romoff,SEEK_SET);
        fputc(readbyte,ROM);
        compsize++;
        romoff++;
     }
     else
     {
        fontoff++;
        fseek(font,fontoff,SEEK_SET);
        readbyte2=fgetc(font);
        if(readbyte==readbyte2&&readbyte2==0)
        {
            backoff=fontoff;
            reps=1;
            fontoff++;
            while(readbyte==0)
            {
                fseek(font,fontoff,SEEK_SET);
                readbyte=fgetc(font);
                fontoff++;
                reps++;
            }
            fontoff--;
            if(reps>=3)  //need at least 3 same bytes to use compression
            {
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)0xBB,ROM);
                compsize++;
                romoff++;
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)reps,ROM);
                compsize++;
                romoff++;
                fontoff--;
            }
            else
            {
                fontoff=backoff-1;
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)0,ROM);
                compsize++;
                romoff++;
            }
        }
        else if(readbyte==readbyte2&&readbyte2==0xFF)
        {
            backoff=fontoff;
            reps=1;
            fontoff++;
            while(readbyte==0xFF)
            {
                fseek(font,fontoff,SEEK_SET);
                readbyte=fgetc(font);
                fontoff++;
                reps++;
            }
            fontoff--;
            if(reps>=3)  //need at least 4 same bytes to use compression
            {
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)0xCC,ROM);
                romoff++;
                compsize++;
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)reps,ROM);
                romoff++;
                compsize++;
                fontoff--;
            }
            else
            {
                fontoff=backoff-1;
                fseek(ROM,romoff,SEEK_SET);
                fputc((unsigned char)0xFF,ROM);
                romoff++;
                compsize++;
            }
        }
        else if(readbyte==readbyte2) //CHECK: DD - many same bytes in a row
        {
           fontoff++;
           fseek(font,fontoff,SEEK_SET);
           readbyte2=fgetc(font);
           if(readbyte2==readbyte)      //found 3 same bytes in a row
           {
               fontoff++;
               fseek(font,fontoff,SEEK_SET);
               readbyte2=fgetc(font);
               if(readbyte2==readbyte)      //found 4 same bytes in a row
               {
                  reps=3;
                  while(readbyte2==readbyte)
                  {
                      reps++;
                      fontoff++;
                      fseek(font,fontoff,SEEK_SET);
                      readbyte2=fgetc(font);
                  }
                  fontoff--;
                  fseek(ROM,romoff,SEEK_SET);
                  fputc((unsigned char)0xDD,ROM);
                  romoff++;
                  compsize++;
                  fseek(ROM,romoff,SEEK_SET);
                  fputc((unsigned char)readbyte,ROM);
                  romoff++;
                  compsize++;
                  fseek(ROM,romoff,SEEK_SET);
                  fputc((unsigned char)reps,ROM);
                  romoff++;
                  compsize++;
               }
               else
               {
               fontoff=fontoff-3;
               fseek(ROM,romoff,SEEK_SET);
               fputc(readbyte,ROM);
               romoff++;
               compsize++;
               }
           }
           else
           {
           fontoff=fontoff-2;           //undo this check, and the first check.
           fseek(ROM,romoff,SEEK_SET);
           fputc(readbyte,ROM);
           romoff++;
           compsize++;
           }
        }
        else
        {
           fontoff--;
           fseek(ROM,romoff,SEEK_SET);
           fputc(readbyte,ROM);
           romoff++;
           compsize++;
        }
     }
     fontoff++;
  }
  fseek(ROM,romoff,SEEK_SET);
  fputc((unsigned char)0xEE,ROM);
  compsize++;
  cout<<"Compressed data takes "<<compsize<<"/1603 bytes.\n";
  getch();
  return 0;
}
